SimpleHUD = LibStub("AceAddon-3.0"):NewAddon("SimpleHUD", "AceEvent-3.0", "AceTimer-3.0", "AceConsole-3.0")
local SimpleHUD = SimpleHUD
local f = CreateFrame("Frame", nil, UIParent)
f:Hide()
local t = f:CreateTexture(nil, "TOOLTIP")
t:SetTexture("Interface\\AddOns\\SimpleHUD\\hud")
t:SetAlpha(0.2)
t:SetVertexColor(0.5,0.5,1)
t.l = f:CreateTexture(nil, "TOOLTIP")
t.l:SetTexture(0.5,0.5,1)
t.l:SetAlpha(0.2)
local sh = t.SetHeight
local sw = t.SetWidth
local sh2 = t.l.SetHeight
local sw2 = t.l.SetWidth
t.l.SetWidth = nil
t.l.SetHeight = nil
t:SetPoint("TOPLEFT", t.l, "TOPRIGHT")
t:SetPoint("BOTTOMLEFT", t.l, "BOTTOMRIGHT")
t.l:SetPoint("LEFT", UIParent, "LEFT")
f:SetPoint("TOPLEFT", t.l, "TOPLEFT")
f:SetPoint("BOTTOMRIGHT", t, "BOTTOMRIGHT")
function f:SetHeight(height)
	local a = type(height)
	if a ~= "number" then height = tonumber(height) end
	if not height then error("Invalid argument #1 to :SetHeight(height). Expected number, got "..a..".") end
	sh2(t.l, height)
	SimpleHUD.db.height = height
end
function f:SetWidth(width)
	local a = type(width)
	if a ~= "number" then width = tonumber(width) end
	if not width then error("Invalid argument #1 to :SetWidth(width). Expected number, got "..a..".") end
	if width > 400 then
		sw(t, 400)
		sw2(t.l, width-400)
	else
		sw(t, width)
		sw2(t.l, 0)
	end
	SimpleHUD.db.width = width
end
local gw=t.GetWidth
local gw2 = t.l.GetWidth
t.l.GetWidth = nil
function f:GetWidth()
	return gw(t)+gw2(t.l)
end
function f:GetHeight()
	return t.l:GetHeight()
end
local move = CreateFrame("Frame", nil, f)
move:SetPoint("CENTER", t, "RIGHT")
move:SetWidth(10)
move:SetHeight(10)
move.t = move:CreateTexture(nil, "BACKGROUND")
move.t:SetTexture(1,0,0)
move.t:SetAllPoints()
move:EnableMouse(true)
move:SetMovable(true)
move:SetScript("OnMouseDown", function()
	move:StartMoving()
	move:SetScript("OnUpdate", function(self)
		t.l:ClearAllPoints()
		t.l:SetPoint("LEFT", UIParent, "BOTTOMLEFT", 0, self:GetBottom()+5)
		SimpleHUD.db.bottom = self:GetBottom()+5
		t:SetWidth(self:GetLeft()+5)
	end)
	move:SetScript("OnHide", function(self)
		self:GetScript("OnMouseUp")()
	end)
end)
move:SetScript("OnMouseUp", function()
	move:StopMovingOrSizing()
	move:SetScript("OnUpdate", nil)
	move:SetScript("OnHide", nil)
	move:ClearAllPoints()
	move:SetPoint("CENTER", t, "RIGHT")
end)
move:Hide()
SlashCmdList["SHUD"] = function(input)
	local cmd, args = string.match(input, "(%S+) (.+)")
	if not cmd then cmd = input end
	if cmd == "mover" then
		move[move:IsShown() and "Hide" or "Show"](move)
	else
		LibStub("AceConfigDialog-3.0"):Open("SimpleHUD")
	end
end
SLASH_SHUD1 = "/shud"
f.t = t
f.m = move
SimpleHUD.f = f
function SimpleHUD:UpdateVisibility()
	if not self.db then return end
	for i,k in pairs(self.db.conds) do
		if i=="target" then
			if not UnitExists("target") and k~="nofilter" then SimpleHUD:Hide() return end
			if not (k=="all" or k=="nofilter" or (k=="harm" and UnitCanAttack("player", "target")) or (k=="help" and UnitCanAssist("player", "target"))) then SimpleHUD:Hide() return end
		elseif i == "spec" then
			if not k[GetActiveTalentGroup()] then return end
		end
	end
	SimpleHUD:Show()
end
SimpleHUD:RegisterEvent("PLAYER_TARGET_CHANGED", "UpdateVisibility")
SimpleHUD:RegisterEvent("PLAYER_TALENT_UPDATE", "UpdateVisibility")
local defaults={profile={
	plugins = {},
	width=698,
	height=768,
	bottom=428,
	speed=0.5,
	conds={
		target="nofilter",
		spec={
			[1]=true,
			[2]=true,
		}
	}
}}
local options = {
	type="group",
	args={
		ownoptions={
			name="SimpleHUD options",
			type="group",
			desc="SimpleHUD configuration",
			order=1,
			args={
				height ={
					type="input",
					name="Height",
					get=function() return tostring(SimpleHUD.db.height) end,
					set=function(info, value) SimpleHUD.f:SetHeight(tonumber(value)) end,
					order=1,
				},
				speed={
					type="range",
					name="Toggle speed",
					desc="How fast the HUD extends/retracts",
					min=0.1,
					max=3.5,
					get=function() return SimpleHUD.db.speed end,
					set=function(info, value) SimpleHUD.db.speed = value end,
					order=2,
				},
				visibility={
					type="group",
					name="Visibility settings",
					desc="When to show the HUD",
					order=3,
					dialogInline=true,
					args={
						target={
							type="group",
							name="Target filtering",
							order=1,
							dialogInline=true,
							args={
								nofilter={
									type="toggle",
									name="Don't filter",
									desc="Display the HUD regardless of target",
									order=1,
									get = function() return SimpleHUD.db.conds.target == "nofilter" end,
									set = function() SimpleHUD.db.conds.target = "nofilter" SimpleHUD:UpdateVisibility() end,
								},
								all={
									type="toggle",
									name="All targets",
									desc="Display for all targets, but only if you have a target",
									order=2,
									get=function() return SimpleHUD.db.conds.target=="all" end,
									set=function() SimpleHUD.db.conds.target="all" SimpleHUD:UpdateVisibility() end,
								},
								harm={
									type="toggle",
									name="Enemy targets",
									desc="Display the HUD only if your target is an enemy",
									order=3,
									get=function() return SimpleHUD.db.conds.target=="harm" end,
									set=function() SimpleHUD.db.conds.target="harm" SimpleHUD:UpdateVisibility() end,
								},
								help={
									type="toggle",
									name="Friendly targets",
									desc="Display the HUD only if your target is friendly",
									order=4,
									get=function() return SimpleHUD.db.conds.target=="help" end,
									set=function() SimpleHUD.db.conds.target="help" SimpleHUD:UpdateVisibility() end,
								},
							},
						},
						specs={
							type="group",
							name="Talent spec filtering",
							order=2,
							dialogInline=true,
							args={
								spec1={
									type="toggle";
									name=function() local talents,talents2={},{} for i=1, GetNumTalentTabs() do local name,icon,points = GetTalentTabInfo(i,false,false,1) talents[i]={name=name,points=points,id=i} talents2[i]={id=i,points=points} end table.sort(talents2, function(a,b) return a.points > b.points end) return "Spec 1 - "..talents[1].points.."/"..talents[2].points.."/"..talents[3].points.." "..(talents2[1].points > talents2[2].points and talents[talents2[1].id].name or (talents2[2].points > talents2[3].points and talents[talents2[1].id].name.."/"..talents[talents2[2].id].name) or "Undefined") end,
									desc="Display the HUD in your primary spec",
									order=1,
									get=function() return SimpleHUD.db.conds.spec[1] end,
									set=function(info, value) SimpleHUD.db.conds.spec[1] = value SimpleHUD:UpdateVisibility() end,
									width="full",
									disabled=function() return GetNumTalentGroups() < 1 end,
								},
								spec2={
									type="toggle",
									name=function() local talents,talents2={},{} for i=1, GetNumTalentTabs() do local name,icon,points = GetTalentTabInfo(i,false,false,2) talents[i]={name=name,points=points,id=i} talents2[i]={id=i,points=points} end table.sort(talents2, function(a,b) return a.points > b.points end) return "Spec 2 - "..talents[1].points.."/"..talents[2].points.."/"..talents[3].points.." "..(talents2[1].points > talents2[2].points and talents[talents2[1].id].name or (talents2[2].points > talents2[3].points and talents[talents2[1].id].name.."/"..talents[talents2[2].id].name) or "Undefined") end,
									desc="Display the HUD in your secondary spec",
									order=2,
									get=function() return SimpleHUD.db.conds.spec[2] end,
									set=function(info, value) SimpleHUD.db.conds.spec[2] = value SimpleHUD:UpdateVisibility() end,
									width="full",
									disabled=function() return GetNumTalentGroups() < 2 end,
								},
							},
						},
					},
				},
			},
		},
		pluginoptions={
			name="Plugin options",
			type="group",
			desc="Plugin configuration",
			order=2,
			args={
			},
		},
	},
}
function SimpleHUD:Hide()
	if (not SimpleHUD.shown) or SimpleHUD.shown == -1 then return end
	SimpleHUD.shown = -1
	local a = self.f:GetWidth()
	local b = GetTime()
	local c = a/self.db.speed
	local d = b+self.db.speed
	self.f:SetScript("OnUpdate", function(self)
		if GetTime() >= d then
			self:SetScript("OnUpdate", nil)
			self:Hide()
			SimpleHUD.shown = false
			SimpleHUD:UpdateVisibility()
		else
			self.t.l:ClearAllPoints()
			self.t.l:SetPoint("LEFT", UIParent, "BOTTOMLEFT", (GetTime()-b)*c*(-1), SimpleHUD.db.bottom)
		end
	end)
end
function SimpleHUD:Show()
	if SimpleHUD.shown then return end
	SimpleHUD.shown = -1
	self.f:Show()
	local a = self.f:GetWidth()
	local b = GetTime()+self.db.speed
	local c = a/self.db.speed
	self.f:SetScript("OnUpdate", function(self)
		if GetTime() >= b then
			self:SetScript("OnUpdate", nil)
			self.t.l:ClearAllPoints()
			self.t.l:SetPoint("LEFT",UIParent,"BOTTOMLEFT",0, SimpleHUD.db.bottom)
			SimpleHUD.shown = true
			SimpleHUD:UpdateVisibility()
		else
			self.t.l:ClearAllPoints()
			self.t.l:SetPoint("LEFT", UIParent, "BOTTOMLEFT", (b-GetTime())*c*(-1), SimpleHUD.db.bottom)
		end
	end)
end
local RegisteredPlugins = {}
function SimpleHUD:OnProfileEnable()
	self.db = self.fdb.profile
end
function SimpleHUD:OnInitialize()
	self.fdb = LibStub("AceDB-3.0"):New("sHUD_DB", defaults)
	options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.fdb)
	LibStub("LibDualSpec-1.0"):EnhanceDatabase(self.fdb, "SimpleHUD")
	LibStub("LibDualSpec-1.0"):EnhanceOptions(options.args.profiles, self.fdb)
	options.args.profiles.order = -1
	self.fdb.RegisterCallback(self, "OnProfileChanged", "OnProfileEnable")
	self.fdb.RegisterCallback(self, "OnProfileCopied", "OnProfileEnable")
	self.fdb.RegisterCallback(self, "OnProfileReset", "OnProfileEnable")
	self.db = self.fdb.profile
	for i,k in pairs(RegisteredPlugins) do
		k()
		RegisteredPlugins[i] = nil
	end
	function self:RegisterForLoad(func)
		func()
	end
	self.f:SetWidth(self.db.width)
	self.f:SetHeight(self.db.height)
	self.f.t.l:SetPoint("LEFT", UIParent, "BOTTOMLEFT", 0, self.db.bottom)
	self:UpdateVisibility()
end
function SimpleHUD:RegisterForLoad(func)
	tinsert(RegisteredPlugins, func)
end
function SimpleHUD:SortPluginOptions()
	local t, s = {}, {}
	for plugin in pairs(options.args.pluginoptions.args) do
		tinsert(t, plugin)
	end
	table.sort(t)
	for i,k in ipairs(t) do
		s[k]=i
	end
	for key, ta in pairs(options.args.pluginoptions.args) do
		ta.order = s[key]
	end
end
function SimpleHUD:RegisterPlugin(name, width, height, defaults)
	if not SimpleHUD.plugins then SimpleHUD.plugins = {} end
	if SimpleHUD.plugins[name] then error("SimpleHUD: Duplicate plugin "..name..", aborting.") end
	local pf = CreateFrame("Frame", nil, self.f)
	pf:SetMovable(true)
	local move = CreateFrame("Frame", nil, pf)
	move:SetAllPoints()
	move:EnableMouse(true)
	move:SetScript("OnMouseDown", function()
		pf:StartMoving()
	end)
	move:SetScript("OnMouseUp", function()
		pf:StopMovingOrSizing()
		local a = SimpleHUD.db.plugins[name].pos
		a.point, a.x, a.y = "BOTTOMLEFT", (pf:GetLeft()-self.f:GetLeft()), (pf:GetBottom()-self.f:GetBottom())
		pf:ClearAllPoints()
		pf:SetPoint(a.point, a.x, a.y)
		if pf:GetRight() > (self.f:GetWidth()-90) then
			self.f:SetWidth(pf:GetRight()+90)
		end
		if pf:GetTop() > self.f:GetTop() then
			a.y = self.f:GetHeight()-pf:GetHeight()
			pf:ClearAllPoints()
			pf:SetPoint(a.point, a.x, a.y)
		end
	end)
	move.t = move:CreateTexture(nil, "BACKGROUND")
	move.t:SetAllPoints()
	move.t:SetTexture(0.7,0.7,0.7)
	move.t:SetAlpha(0.5)
	move.text = move:CreateFontString(nil, "ARTWORK")
	move.text:SetAllPoints()
	move.text:SetFont("Fonts\\FRIZQT__.TTF", 8, "OUTLINE")
	move.text:SetTextColor(1,1,1)
	move.text:SetText("Drag to move")
	move:Hide()
	if not self.db.plugins[name] then self.db.plugins[name] = defaults or {} self.db.plugins[name].pos={point="CENTER", x=0, y=0} move:Show() end
	pf:SetPoint(self.db.plugins[name].pos.point, self.db.plugins[name].pos.x, self.db.plugins[name].pos.y)
	local tw, th = type(width), type(height)
	if tw ~= "number" then width = tonumber(width) end
	if th ~= "number" then height = tonumber(height) end
	if not width then error("Invalid argument #2 to SimpleHUD:RegisterPlugin(name, width, height). Expected number, got "..tw..".") end
	if not height then error("Invalid argument #3 to SimpleHUD:RegisterPlugin(name, width, height). Expected number, got "..th..".") end
	pf:SetWidth(width)
	pf:SetHeight(height)
	local o = {type="group",
		name=name,
		desc=name.." configuration",
		args={},
	}
	options.args.pluginoptions.args[name]=o
	self:SortPluginOptions()
	SimpleHUD.plugins[name] = {frame=pf, table=self.db.plugins[name], options=o.args}
	SimpleHUD.numplugins = (SimpleHUD.numplugins or 0)+1
	local pot = options.args.pluginoptions.args
	pot[tostring(#pot+1)] = {name=function() return move:IsShown() and "Stop moving "..name or "Move "..name end, func=function() move[move:IsShown() and "Hide" or "Show"](move) end,type="execute"}
	return pf, self.db.plugins[name], o.args
end
LibStub("AceConfig-3.0"):RegisterOptionsTable("SimpleHUD", options)
