print(...)
local function OnLoad()
	local frame, db, config = SimpleHUD:RegisterPlugin("Rotation", 0, 0, {size=40})
	frame:SetHeight(db.size)
	local buttons = {}
	local ch
	local function iterateall()
		for n,b in ipairs(buttons) do
			b:GetScript("OnEvent")(b)
		end
	end
	setmetatable(buttons, {__index=function(t,v)
		t[v]=CreateFrame("Frame", nil, frame)
		t[v]:SetPoint("TOPLEFT", (v-1)*db.size, 0)
		t[v]:SetWidth(db.size)
		t[v]:SetHeight(db.size)
		t[v].tex = t[v]:CreateTexture(nil, "BACKGROUND")
		t[v].tex:SetAlpha(0.4)
		t[v].tex:SetAllPoints()
		local h = t[v].Hide
		local s = t[v].Show
		local x = t[v]
		function x:Hide()
			h(x)
			local co = 0
			while (buttons[co+1] and buttons[co+1]:IsShown()) do
				co = co+1
			end
			frame:SetWidth(db.size*co)
		end
		function x:Show()
			s(x)
			local co = 0
			while buttons[co+1] and buttons[co+1]:IsShown() do
				co = co+1
			end
			frame:SetWidth(db.size*co)
		end
		t[v]:Hide()
		t[v]:SetScript("OnEvent", function(self) if not self:IsShown() then return end
			if (not ch or (ch < v)) and db.spells[v].filter() then
				if ch then
					t[ch].tex:SetAlpha(0.4)
				end
				ch=v
				self.tex:SetAlpha(0.8)
			end
			if ch == v and not db.spells[v].filter() then
				self.tex:SetAlpha(0.4)
				ch = nil
				iterateall()
			end
		end)
		return t[v]
	end})
	if not db.spells then db.spells = {} end
	config.size = {type="input",
		name="Size",
		desc="Set the buttons' size",
		order=1,
		get=function() return tostring(db.size) end,
		set=function(info, value) db.size = tonumber(value) for id, btn in ipairs(buttons) do btn:SetWidth(tonumber(value)) btn:SetHeight(tonumber(value)) btn:SetPoint("TOPLEFT", (id-1)*db.size, 0) end frame:SetHeight(tonumber(value)) local scnt = 0 while buttons[scnt+1] and buttons[scnt+1]:IsShown() do scnt = scnt+1 end frame:SetWidth(tonumber(value)*scnt) end,
	}
	config.rotation = {type="group",
		name="Rotation",
		desc="Configure your rotation",
		args={},
		order=-1,
		dialogInline=true,
	}
	for num, data in ipairs(db.spells) do
		config.rotation.args["spell"..num] = {
			type="group",
			dialogInline = true,
			name = "",
			args={
				editbox = {
					type="input",
					name="Spell name",
					desc="Usage: <spell name> or <spell ID>",
					get=function() return db.spells[num].name end,
					set=function(info, value) if not GetSpellInfo(tonumber(value) or value) then return end db.spells[num].name = value buttons[num].tex:SetTexture((select(3, GetSpellInfo(tonumber(value) or value)))) end,
					order = 1,
				},
				events = {
					type="input",
					name="Events",
					desc="Usage: <event1>,<event2>,<event3>,...",
					get=function() return db.spells[num].events end,
					set=function(info,value) buttons[num]:UnregisterAllEvents() for event in string.gmatch(value, "[^,]+") do buttons[num]:RegisterEvent(event) end db.spells[num].events=value end,
					order=2,
				},
				filter = {
					type="input";
					multiline = true,
					name="Highlight if:",
					desc="Usage: <lua code>. True means highlight.",
					get = function() return db.spells[num].filterc end,
					set = function(info, value) db.spells[num].filterc = value db.spells[num].filter = loadstring(value) end,
					order = 3,
				},
				remove={
					type="execute",
					name="Remove!",
					desc="Remove this spell!",
					func=function() local c = 1 while config["spell"..c] do c=c+1 end config["spell"..(c-1)] = nil buttons[#buttons]:Hide() tremove(db.spells, num) end,
					order=4,
				},
			},
			order=num,
		}
		buttons[num]:Show()
		for event in string.gmatch(data.events, "[^,]+") do
			buttons[num]:RegisterEvent(event)
		end
		buttons[num].tex:SetTexture((select(3, GetSpellInfo(tonumber(data.name) or data.name))))
		db.spells[num].filter = loadstring(db.spells[num].filterc)
		buttons[num]:GetScript("OnEvent")(buttons[num])
	end
	config.rotation.args.add = {
		type="execute",
		name="Add spell",
		desc="Add another spell",
		func=function() local num = 1
			while config.rotation.args["spell"..num] do
				num=num+1
			end
			db.spells[num] = {name="", events="",filterc="return false", filter=function() return false end}
			config.rotation.args["spell"..num] = {
				type="group",
				dialogInline = true,
				name = "",
				args={
					editbox = {
						type="input",
						name="Spell name",
						desc="Usage: <spell name> or <spell ID>",
						get=function() return db.spells[num].name end,
						set=function(info, value) if not GetSpellInfo(value) then return end db.spells[num].name = value buttons[num].tex:SetTexture((select(3, GetSpellInfo(value)))) end,
						order = 1,
					},
					events = {
						type="input",
						name="Events",
						desc="Usage: <event1>,<event2>,<event3>,...",
						get=function() return db.spells[num].events end,
						set=function(info,value) buttons[num]:UnregisterAllEvents() for event in string.gmatch(value, "[^,]+") do buttons[num]:RegisterEvent(event) end db.spells[num].events = value end,
						order=2,
					},
					filter = {
						type="input";
						multiline = true,
						name="Highlight if:",
						desc="Usage: <lua code>. True means highlight.",
						get = function() return db.spells[num].filterc end,
						set = function(info, value) db.spells[num].filterc = value db.spells[num].filter = loadstring(value) end,
						order = 3,
					},
					remove={
						type="execute",
						name="Remove!",
						desc="Remove this spell!",
						func=function() tremove(db.spells, num) local c = 1 while config["spell"..c] do c=c+1 end config["spell"..(c-1)] = nil end,
						order=4,
					},
				},
				order=num,
			}
			buttons[num]:Show()
		end,
		order=-1,
	}
end
SimpleHUD:RegisterForLoad(OnLoad)